﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinExplorerBar;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Form GroupForm;
        private Timer timer;

        private bool TimerStarted { get; set; }
        private bool ValidFormTarget { get; set; }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            
            if (disposing)
            {
                if (this.GroupForm != null)
                {
                    this.CleanupGroupForm();
                }    
            }

            base.Dispose(disposing);
        }

        private void ultraExplorerBar1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is NavigationOverflowButtonUIElement)
            {
                this.ValidFormTarget = true;
                NavigationOverflowButtonUIElement buttonUiElement = (NavigationOverflowButtonUIElement)e.Element;
                if (buttonUiElement.Group != null)
                {
                    ShowGroupForm(buttonUiElement.Group.Key);
                }
            }
        }

        private void ShowGroupForm(string groupKey)
        {
            if (GroupForm == null)
            {
                GroupForm = new Form();
                GroupForm.ControlBox = false;
                GroupForm.Size = new Size(220, 215);
                GroupForm.MouseEnter += new EventHandler(GroupForm_MouseEnter);
                GroupForm.MouseLeave += new EventHandler(GroupForm_MouseLeave);
                GroupForm.Controls.Add(new Label());
            }

            if (GroupForm.Controls.Count == 1)
            {
                Label label;
                switch (groupKey)
                {
                    case "Group1":
                        label = GroupForm.Controls[0] as Label;
                        if (label != null)
                        {
                            label.Text = "Hello Group 1";
                        }
                        GroupForm.BackColor = Color.Chartreuse;
                        break;
                    case "Group2":
                        label = GroupForm.Controls[0] as Label;
                        if (label != null)
                        {
                            label.Text = "Hello Group 2";
                        }
                        GroupForm.BackColor = Color.Yellow;
                        break;
                    case "Group3":
                        label = GroupForm.Controls[0] as Label;
                        if (label != null)
                        {
                            label.Text = "Hello Group 3";
                        }
                        GroupForm.BackColor = Color.Aqua;
                        break;
                    default:
                        break;
                }
            }

            Point groupFormLocation = Point.Empty;
            NavigationOverflowButtonAreaUIElement navigationOverflowButtonAreaUIElement = this.ultraExplorerBar1.NavigationOverflowButtonAreaUIElement;
            if (navigationOverflowButtonAreaUIElement != null)
            {
                groupFormLocation = navigationOverflowButtonAreaUIElement.Control.PointToScreen(navigationOverflowButtonAreaUIElement.Rect.Location);
                groupFormLocation.Offset(0, -GroupForm.Height - 10);
            }
            GroupForm.StartPosition = FormStartPosition.Manual;
            GroupForm.Location = groupFormLocation;

            GroupForm.Show();
        }

        void GroupForm_MouseLeave(object sender, EventArgs e)
        {
            this.ValidFormTarget = false;
        }

        void GroupForm_MouseEnter(object sender, EventArgs e)
        {
            this.ValidFormTarget = true;
        }
        
        private void ultraExplorerBar1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is NavigationOverflowButtonUIElement)
            {
                this.ValidFormTarget = false;
                if (!this.TimerStarted)
                {
                    this.TimerStarted = true;
                    this.timer.Start();
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer = new Timer();
            timer.Interval = 1500;
            timer.Tick += new EventHandler(timer_Tick);
        }

        void timer_Tick(object sender, EventArgs e)
        {
            if (!this.ValidFormTarget)
            {
                this.StopTimer();
                this.CleanupGroupForm();
            }
        }

        private void StopTimer()
        {
            this.TimerStarted = false;
            this.timer.Stop();
        }

        private void CleanupGroupForm()
        {
            if (GroupForm != null)
            {
                GroupForm.Close();
                GroupForm.MouseEnter -= GroupForm_MouseEnter;
                GroupForm.MouseLeave -= GroupForm_MouseEnter;
                GroupForm.Dispose();
                GroupForm = null;
            }
        }
    }
}
